
import javax.microedition.lcdui.Graphics;

/**
 * Entre 2 Almas	[https://sourceforge.net/projects/entre2almas/]  
 * ------------------------------------------------------------------------
 * This file is part of "Entre 2 Almas".
 * "Entre 2 Almas" is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * "Entre 2 Almas" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "Entre 2 Almas"; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * ------------------------------------------------------------------------
 * 		Copyright 2005 - 2006 Pedro Javier Sez Martnez
 * 
 * 
 * Interfaz que define que mtodos deber usar un men. Es un patrn factory, el
 * cual permite adaptar ms fcilmente la interfaz a los distintos tipo de
 * mviles.
 * 
 * @author Pedro Javier Sez Martnez
 * @version 1.0
 */
public interface UIFactory {

	/**
	 * Dibuja la pantalla del men principal
	 * 
	 * @param g
	 *            Objeto Graphics
	 */
	public abstract void getMenuPrincipal(Graphics g);

	/**
	 * Muestra las opciones que hay dentro de "Memoria"
	 * 
	 * @param g
	 *            Objeto Graphics
	 */
	public abstract void getPantallaMemoria(Graphics g);

	/**
	 * Entrar en el men de opciones
	 * 
	 * @param g
	 *            Objeto Graphics
	 */
	public abstract void getPantallaOpciones(Graphics g);

	/**
	 * Dibuja el contenido de la "Ayuda"
	 * 
	 * @param g
	 *            Objeto Graphics
	 */
	public abstract void getPantallaAyuda(Graphics g);

	/**
	 * Dibuja el contenido de las distintas opciones de la ayuda
	 * 
	 * @param g
	 *            Objeto Graphics
	 */
	public void getPantallaSubAyuda(Graphics g);

	/**
	 * Muestra el contenido de la "Acerca de..."
	 * 
	 * @param g
	 *            Objeto Graphics
	 */
	public abstract void getPantallaAcerca(Graphics g);

}
