import java.util.Vector;

import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.game.Sprite;

/**
 * Entre 2 Almas	[https://sourceforge.net/projects/entre2almas/]  
 * ------------------------------------------------------------------------
 * This file is part of "Entre 2 Almas".
 * "Entre 2 Almas" is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * "Entre 2 Almas" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with "Entre 2 Almas"; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * ------------------------------------------------------------------------
 * 		Copyright 2005 - 2006 Pedro Javier Sez Martnez
 * 
 * 
 * Men de bajo nivel, es decir, que ser igual en todos los mviles, pero es ms
 * colorido, ms bonito, ms vistoso
 * 
 * @author Pedro Javier Sez Martnez
 * @version 1.0
 */
public class UITerminalSTBG extends Canvas implements UIFactory, CommandListener{
	
	/**
	 * Midlet del juego
	 */
	private Entre2Almas midlet;
	
	/**
	 * sprite que albergar las imgenes de fondo.
	 */
	private Sprite sprite;
	
	/**
	  * Comando volver, el cual tendr prioridad 0.Se utiliza en la
	  * pantalla de ayuda, de opciones y de memoria
	 */
	private Command volverCommand = new Command("Volver", Command.BACK,0);

	/**
	  * Comando Elegir, el cual tendr prioridad 1.Se utiliza en el men
	  * principal
	 */
	private Command selectCommand = new Command("Elegir", Command.OK,1);
	
	/**
	  * Comando Salir, el cual tendr prioridad 0.Se utiliza en el men 
	  * principal
	 */
	private Command salirCommand = new Command("Salir", Command.EXIT,0);
	
	/**
	  * Comando aceptar, el cual tendr prioridad 1.Se utiliza en la
	  * pantalla de opciones
	 */
	private Command acceptCommand = new Command("Aceptar", Command.BACK,1);
	
	/**
	 * Indica cual de las opciones del men opciones est seleccionada.
	 */
	private int menuOpIdx;
	
	/**
	 * Indica cual de las opciones del men memoria est seleccionada.
	 */
	private int menuMemIdx;

	/**
	 * Opciones de los mens
	 */
	private Vector opciones;
	


	public UITerminalSTBG(Entre2Almas midlet) {
		//Ponemos la pantalla a modo completo. Hay que poner esto antes
		//de saber en que grupo est el mvil, porque si no est 
		//a fullScreen la zona de comandos come una parte de la pantalla
		//lo cual hace que getHeight() sea menor que el valor absoluto real
		setFullScreenMode(true);
		
		//Obtenemos el grupo al que pertenece el mvil.
		Utils.getGrupo(getWidth(),getHeight());
		
		ajustarVariables();
		this.midlet=midlet;
		
		Utils.mensaje=new StringBuffer();
		Utils.palabrasMensaje=new Vector();
		
		opciones = new Vector();
		
		Utils.cargada=-1;
		Utils.parteMenu = Utils.menuPrin;

		// Se establece como opcin seleccionada la primera del men
		Utils.menuPrinIdx = 0;

		//cargamos el fondo de pantalla del men principal
		Utils.cargarImagen(Utils.imMenuPrin);
		sprite = new Sprite(Utils.imagen, Utils.anchoIm, Utils.altoIm);
		sprite.setFrameSequence(Utils.getFrames(Utils.imMenuPrin));
		
//		situamos el frame del sprite en el centro de la pantalla
		sprite.setPosition((Utils.width / 2) - (sprite.getWidth() / 2),
				(Utils.height / 2) - (sprite.getHeight() / 2));
		sprite.setVisible(true);

		//Establecemos el CommadnListener
	    setCommandListener(this);

	}

	/**
	 * Dibuja la pantalla del men principal
	 * 
	 * @param g
	 *            objeto Graphics
	 */
	public void getMenuPrincipal(Graphics g) {
		sprite.paint(g);
		
		g.setFont(Utils.lowFont);
		g.setColor(Utils.lowColor);
		int size=opciones.size();
		for (int i = 0; i < size; i++) {
			//Si la opcin esta seleccionada, utilizamos highFont, highColor
			if (i == Utils.menuPrinIdx) {
				g.setFont(Utils.highFont);

				g.setColor(Utils.highColor);
				g.drawString((String) opciones.elementAt(i), (Utils.width - Utils.highFont
						.stringWidth((String) opciones.elementAt(i))) / 2, Utils.startHeight
						+ (i * Utils.highFont.getHeight())+ Utils.spacing, Graphics.TOP|Graphics.LEFT);
				g.setFont(Utils.lowFont);
				g.setColor(Utils.lowColor);

			} else {
				//si la opcin no esta seleccionada, utilizamos
				//lowFonto y lowColor
				g.drawString((String) opciones.elementAt(i), (Utils.width - Utils.lowFont
						.stringWidth((String) opciones.elementAt(i))) / 2, Utils.startHeight
						+ (i * Utils.highFont.getHeight())+ Utils.spacing, Graphics.TOP|Graphics.LEFT);
			}
		}
	}

	/**
	 * Muestra las opciones que hay dentro de "Memoria"
	 */
	public void getPantallaMemoria(Graphics g) {
		sprite.paint(g);
		
		g.setFont(Utils.lowFont);
		g.setColor(Utils.lowColor);
		int size=opciones.size();
		for (int i = 0; i < size; i++) {
			//Si la opcin esta seleccionada, utilizamos highFont, highColor
			if (i == menuMemIdx) {
				g.setFont(Utils.highFont);

				g.setColor(Utils.highColor);
				g.drawString((String) opciones.elementAt(i), (Utils.width - Utils.highFont
						.stringWidth((String) opciones.elementAt(i))) / 2, Utils.startHeight
						+ (i * Utils.highFont.getHeight())+ Utils.spacing, Graphics.TOP|Graphics.LEFT);
				g.setFont(Utils.lowFont);
				g.setColor(Utils.lowColor);

			} else {
				//si la opcin no esta seleccionada, utilizamos
				//lowFonto y lowColor
				g.drawString((String) opciones.elementAt(i), (Utils.width - Utils.lowFont
						.stringWidth((String) opciones.elementAt(i))) / 2, Utils.startHeight
						+ (i * Utils.highFont.getHeight())+ Utils.spacing, Graphics.TOP|Graphics.LEFT);
			}
		}
	}
	
	/**
	 * Muestra la pantalla de guardando
	 */
	public void getPantallaGuardando(Graphics g) {
		if(Utils.guardandoPartida)
			sprite.paint(g);
		else
			Utils.parteMenu=Utils.memoria;
	}
	
	/**
	 * Dibuja el contenido de la "Ayuda"
	 * 
	 * @param g Objeto Graphics
	 */
	public void getPantallaAyuda(Graphics g) {
		sprite.paint(g);
		
		g.setFont(Utils.lowFont);
		g.setColor(Utils.lowColor);
		int size=opciones.size();
		for (int i = 0; i < size; i++) {
			//Si la opcin esta seleccionada, utilizamos highFont, highColor
			if (i == Utils.menuAyudaIdx) {
				g.setFont(Utils.highFont);

				g.setColor(Utils.highColor);
				g.drawString((String) opciones.elementAt(i), (Utils.width - Utils.highFont
						.stringWidth((String) opciones.elementAt(i))) / 2, Utils.startHeight
						+ (i * Utils.highFont.getHeight())+ Utils.spacing, Graphics.TOP|Graphics.LEFT);
				g.setFont(Utils.lowFont);
				g.setColor(Utils.lowColor);

			} else {
				//si la opcin no esta seleccionada, utilizamos
				//lowFonto y lowColor
				g.drawString((String) opciones.elementAt(i), (Utils.width - Utils.lowFont
						.stringWidth((String) opciones.elementAt(i))) / 2, Utils.startHeight
						+ (i * Utils.highFont.getHeight())+ Utils.spacing, Graphics.TOP|Graphics.LEFT);
			}
		}
	}

	/**
	 * Muestra el contenido de la "Acerca de..."
	 */
	public void getPantallaAcerca(Graphics g) {
		System.gc();
		sprite.paint(g);

		g.setFont(Utils.lowFont);
		g.setColor(Utils.highColor);
		
		//aux2 almacena el numero de letras que lleva una lnea
		int aux2=0;
		//Identifica en que lnea toca imprimir
		int lineaAux=0;
		//Ira almacenando el contenido de una lnea
		StringBuffer aux=new StringBuffer();
		int size=Utils.palabrasMensaje.size();
		int tamPalabra=0;
		String palabra;
		for (int i = 0; i < size; i++) {
			palabra=((String) Utils.palabrasMensaje.elementAt(i));
			tamPalabra=palabra.length()*Utils.widthLF;
			//la ideal sera la de abajo, pero como carga demasiado pues uso la anterior
			//tamPalabra=Utils.lowFont.stringWidth(palabra);
			//Si es salto de lnea, imprimimos y aumentamos en una la lineaAux 
			if (palabra.equals("\\n") ) {
				if(lineaAux >= Utils.linea && lineaAux <= Utils.numLineas + Utils.linea)
					g.drawString(aux.toString(), Utils.startWidth, Utils.startHeight
							+ ((lineaAux - Utils.linea) * Utils.spacing), Graphics.TOP|Graphics.LEFT);
				else if(lineaAux > Utils.numLineas + Utils.linea)size=0;//para salir del bucle
				aux.delete(0, aux.length());
				lineaAux=lineaAux+2;
				aux2 = 0;
			}else {
				if(tamPalabra>Utils.spaceMen){
//					imprimimos lo que hay previamente
					g.drawString(aux.toString(), Utils.startWidth,
							Utils.startHeight + ((lineaAux - Utils.linea) * Utils.spacing),
							Graphics.TOP | Graphics.LEFT);
					aux.delete(0, aux.length());
					lineaAux++;
					aux2 = 0;
					//Imprimimos la primera parte
					int noCaben=(tamPalabra-Utils.spaceMen)/Utils.widthLF;
					aux.append(palabra.substring(0,palabra.length()-noCaben-1));
					g.drawString(aux.toString(), Utils.startWidth, Utils.startHeight
							+ ((lineaAux - Utils.linea) * Utils.spacing), Graphics.TOP|Graphics.LEFT);
					aux.delete(0, aux.length());
					lineaAux++;
					aux2 = 0;
					//Y luego el final que no entraba lo aadimos a la palabra
					//de la siguiente linea
					aux.append(palabra.substring(palabra.length()-noCaben-1) + " ");
					aux2 = aux2 + palabra.substring(palabra.length()-noCaben-1).length()*Utils.widthLF + Utils.lowFont.charWidth(' ');
				}
				else{
					//si el numero de letras de esa lnea (aux2) es menor que el numero
					//de letras que caben en esta pantalla, restndole adems
					//el tamao de la ultima palabra, 
					if (aux2 + tamPalabra<Utils.spaceMen) {
						//Introducimos en aux, la palabra seguida de un espacio
						aux.append(palabra + " ");
						//actualizamos el valor de aux2
						aux2 = aux2 + tamPalabra + Utils.lowFont.charWidth(' ');
					} else {
						//Solo imprime las filas que sern visibles, es decir
						//para no imprimir lneas que no se veran pues estara
						//en la parte negra
						if (lineaAux >= Utils.linea && lineaAux <= Utils.numLineas + Utils.linea)
							g.drawString(aux.toString(), Utils.startWidth,
									Utils.startHeight + ((lineaAux - Utils.linea) * Utils.spacing),
									Graphics.TOP | Graphics.LEFT);
						else if(lineaAux > Utils.numLineas + Utils.linea)size=0;//para salir del bucle
						//al imprimir una lnea borramos el contenido de aux
						aux.delete(0, aux.length());
						//aumentamos el valor de lineaAux
						lineaAux++;
						//aux2 vuelve a ser 0
						aux2 = 0;
						//y en aux metemos la palabra que no se ha introducido
						//en la lnea que se acaba de imprimir, porque el numeroLetras
						//de esa lnea ya sobrepasaba los limites
						aux.append(palabra + " ");
						aux2 = aux2 + tamPalabra + Utils.lowFont.charWidth(' ');
	
					}
				}
			}
			//Cuando llegamos al final, imprimimos la lnea (este como este)
			if(i+1==Utils.palabrasMensaje.size()){
				if(lineaAux>=Utils.linea&&lineaAux<=Utils.numLineas+Utils.linea)
					g.drawString(aux.toString(), Utils.startWidth, Utils.startHeight
							+ ((lineaAux-Utils.linea) * Utils.spacing),Graphics.TOP|Graphics.LEFT);
			}
		}
		//el numero de lneas que ocupa el mensaje.
		Utils.numLineasMensaje=lineaAux;
		//si el numero de lneas que caben en la pantalla + la lnea 
		//en la cual se imprime la primera lnea es menor que el numero
		//de lneas que ocupa el mensaje (teniendo en cuenta que si el 
		//mensaje ocupa 7 lneas, numLineas valdr 6), se pinta una flecha
		//hacia abajo
		if(Utils.numLineas+Utils.linea<Utils.numLineasMensaje){
			g.setColor(0x00000000);
			g.fillTriangle((Utils.width/2)-7,Utils.startHeight
				+ (Utils.numLineas * Utils.spacing)+Utils.spacing,(Utils.width/2),Utils.startHeight
				+ (Utils.numLineas * Utils.spacing)+Utils.spacing+7,(Utils.width/2)+7,Utils.startHeight
				+ (Utils.numLineas * Utils.spacing)+Utils.spacing);
		}

	}
	
	/**
	 * Dibuja el contenido de la pantalla "Opciones"
	 * 
	 * @param g Objeto Graphics
	 */
	public void getPantallaOpciones(Graphics g) {
		sprite.paint(g);
		
		g.setFont(Utils.lowFont);
		g.setColor(Utils.lowColor);
		int size= opciones.size();
		for (int i = 0; i < size; i++) {
			//Si la opcin esta seleccionada, utilizamos highFont, highColor
			if (i == menuOpIdx) {
				g.setFont(Utils.highFont);

				g.setColor(Utils.highColor);
				g.drawString((String) opciones.elementAt(i),Utils.startWidth, Utils.startHeight
						+ (i * Utils.highFont.getHeight())+ Utils.spacing, Graphics.TOP|Graphics.LEFT);
				g.setFont(Utils.lowFont);
				g.setColor(Utils.lowColor);

			} else {
				//si la opcin no esta seleccionada, utilizamos
				//lowFonto y lowColor
				g.drawString((String) opciones.elementAt(i), Utils.startWidth, Utils.startHeight
						+ (i * Utils.highFont.getHeight())+ Utils.spacing, Graphics.TOP|Graphics.LEFT);
			}
		}
	}
	
	/**
	 * Dibuja el contenido de las distintas opciones de la ayuda
	 * 
	 * @param g Objeto Graphics
	 */
	public void getPantallaSubAyuda(Graphics g) {
		System.gc();
		sprite.paint(g);

		g.setFont(Utils.lowFont);
		g.setColor(Utils.highColor);
		
		//aux2 almacena el numero de letras que lleva una lnea
		int aux2=0;
		//Identifica en que lnea toca imprimir
		int lineaAux=0;
		//Ira almacenando el contenido de una lnea
		StringBuffer aux=new StringBuffer();
		int size=Utils.palabrasMensaje.size();
		int tamPalabra=0;
		String palabra;
		for (int i = 0; i < size; i++) {
			palabra=((String) Utils.palabrasMensaje.elementAt(i));
			tamPalabra=palabra.length()*Utils.widthLF;
			//la ideal sera la de abajo, pero como carga demasiado pues uso la anterior
			//tamPalabra=Utils.lowFont.stringWidth(palabra);
			//Si es salto de lnea, imprimimos y aumentamos en una la lineaAux 
			if (palabra.equals("\\n") ) {
				if(lineaAux >= Utils.linea && lineaAux <= Utils.numLineas + Utils.linea)
					g.drawString(aux.toString(), Utils.startWidth, Utils.startHeight
							+ ((lineaAux - Utils.linea) * Utils.spacing), Graphics.TOP|Graphics.LEFT);
				else if(lineaAux > Utils.numLineas + Utils.linea)size=0;//para salir del bucle
				aux.delete(0, aux.length());
//				pasamos a la lnea siguiente y dejamos un hueco en blanco entre medias.
				lineaAux=lineaAux+2;
				aux2 = 0;
			}else {
				if(tamPalabra>Utils.spaceMen){
//					imprimimos lo que hay previamente
					g.drawString(aux.toString(), Utils.startWidth,
							Utils.startHeight + ((lineaAux - Utils.linea) * Utils.spacing),
							Graphics.TOP | Graphics.LEFT);
					aux.delete(0, aux.length());
					lineaAux++;
					aux2 = 0;
					//Imprimimos la primera parte
					int noCaben=(tamPalabra-Utils.spaceMen)/Utils.widthLF;
					aux.append(palabra.substring(0,palabra.length()-noCaben-1));
					g.drawString(aux.toString(), Utils.startWidth, Utils.startHeight
							+ ((lineaAux - Utils.linea) * Utils.spacing), Graphics.TOP|Graphics.LEFT);
					aux.delete(0, aux.length());
					lineaAux++;
					aux2 = 0;
					//Y luego el final que no entraba lo aadimos a la palabra
					//de la siguiente lnea
					aux.append(palabra.substring(palabra.length()-noCaben-1) + " ");
					aux2 = aux2 + palabra.substring(palabra.length()-noCaben-1).length()*Utils.widthLF + Utils.lowFont.charWidth(' ');
				}
				else{
					//si el numero de letras de esa lnea (aux2) es menor que el numero
					//de letras que caben en esta pantalla, restndole adems
					//el tamao de la ultima palabra, 
					if (aux2 + tamPalabra<Utils.spaceMen) {
						//Introducimos en aux, la palabra seguida de un espacio
						aux.append(palabra + " ");
						//actualizamos el valor de aux2
						aux2 = aux2 + tamPalabra + Utils.lowFont.charWidth(' ');
					} else {
						//Solo imprime las filas que sern visibles, es decir
						//para no imprimir lneas que no se veran pues estara
						//en la parte negra
						if (lineaAux >= Utils.linea && lineaAux <= Utils.numLineas + Utils.linea)
							g.drawString(aux.toString(), Utils.startWidth,
									Utils.startHeight + ((lineaAux - Utils.linea) * Utils.spacing),
									Graphics.TOP | Graphics.LEFT);
						else if(lineaAux > Utils.numLineas + Utils.linea)size=0;//para salir del bucle
						//al imprimir una lnea borramos el contenido de aux
						aux.delete(0, aux.length());
						//aumentamos el valor de lineaAux
						lineaAux++;
						//aux2 vuelve a ser 0
						aux2 = 0;
						//y en aux metemos la palabra que no se ha introducido
						//en la lnea que se acaba de imprimir, porque el numeroLetras
						//de esa lnea ya sobrepasaba los limites
						aux.append(palabra + " ");
						aux2 = aux2 + tamPalabra + Utils.lowFont.charWidth(' ');
	
					}
				}
			}
			//Cuando llegamos al final, imprimimos la lnea (este como este)
			if(i+1==Utils.palabrasMensaje.size()){
				if(lineaAux>=Utils.linea&&lineaAux<=Utils.numLineas+Utils.linea)
					g.drawString(aux.toString(), Utils.startWidth, Utils.startHeight
							+ ((lineaAux-Utils.linea) * Utils.spacing),Graphics.TOP|Graphics.LEFT);
			}
		}
		//el numero de lneas que ocupa el mensaje.
		Utils.numLineasMensaje=lineaAux;
		//si el numero de lneas que caben en la pantalla + la lnea 
		//en la cual se imprime la primera lnea es menor que el numero
		//de lneas que ocupa el mensaje (teniendo en cuenta que si el 
		//mensaje ocupa 7 lneas, numLineas valdr 6), se pinta una flecha
		//hacia abajo
		if(Utils.numLineas+Utils.linea<Utils.numLineasMensaje){
			g.setColor(0x00000000);
			g.fillTriangle((Utils.width/2)-7,Utils.startHeight
				+ (Utils.numLineas * Utils.spacing)+Utils.spacing,(Utils.width/2),Utils.startHeight
				+ (Utils.numLineas * Utils.spacing)+Utils.spacing+7,(Utils.width/2)+7,Utils.startHeight
				+ (Utils.numLineas * Utils.spacing)+Utils.spacing);
		}

	}
	
	/**
	 * Decide que y cuando cargar en cada momento
	 * @param g Objeto Graphics
	 * @param pantalla pantalla que se desea cargar (ejemplo ayuda, opciones...)
	 */
	private void cargar(Graphics g, int pantalla){
		switch(pantalla){
			case Utils.menuPrin://pantalla del men principal
				Utils.cargada=Utils.menuPrin;
			
				Utils.linea=0;
				removeCommand(acceptCommand);
				removeCommand(volverCommand);
				addCommand(salirCommand);
				addCommand(selectCommand);
				
				//cargamos el fondo de pantalla del men principal
				Utils.cargarImagen(Utils.imMenuPrin);
				sprite.setImage(Utils.imagen, Utils.anchoIm, Utils.altoIm);
				sprite.setFrameSequence(Utils.getFrames(Utils.imMenuPrin));
				
				//vaciamos el vector opciones
				opciones.removeAllElements();
//				Aadimos las opciones disponibles a la lista.
				if(Utils.jugando) 
					//Si estamos jugando, activamos la opcin de seguir jugando,
					//la cual est situada en la posicin 0 de el array opMenuPrin
					opciones.addElement(Utils.opMenuPrin[0]);
				
				//aadimos el resto de opciones
				for(int i=1;i<Utils.opMenuAyuda.length;i++)
					opciones.addElement(Utils.opMenuPrin[i]);
				//espacio entre las opciones del men principal
				Utils.spacing = Utils.highFont.getHeight() / 2;
				
				//Calcula la altura a la que se muestra la primera de las
				//opciones del men
				//Teniendo en cuenta que hay n-1 opciones en minsculas
				//1 opcin en maysculas, y que luego habr n-1 espacios
				Utils.startHeight = (Utils.lowFont.getHeight() * (opciones.size()-1))
						+ (Utils.highFont.getHeight())
						+ ((opciones.size() - 1) * Utils.spacing);
				Utils.startHeight = (Utils.height - Utils.startHeight) / 2;
				
				g.setColor(0x00000000);
				g.fillRect(0, 0, Utils.width, Utils.height);
				
				getMenuPrincipal(g);
			break;
			case Utils.memoria://pantalla de Memoria
				Utils.cargada=Utils.memoria;
				Utils.linea=0;
				menuMemIdx=0;
				removeCommand(salirCommand);
				addCommand(volverCommand);
				addCommand(selectCommand);
				
//				cargamos el fondo de pantalla de la memoria
				Utils.cargarImagen(Utils.imMemoria);
				sprite.setImage(Utils.imagen, Utils.anchoIm, Utils.altoIm);
				sprite.setFrameSequence(Utils.getFrames(Utils.imMemoria));
				
				//vaciamos el vector opciones
				opciones.removeAllElements();
				//establecemos las opciones de Memoria
				if(Utils.jugando)
					opciones.addElement(Utils.opMenuMemo[0]);
				opciones.addElement(Utils.opMenuMemo[1]);
				//espacio entre las opciones del men principal
				Utils.spacing = Utils.highFont.getHeight() / 2;
				
				//Calcula la altura a la que se muestra la primera de las
				//opciones del men
				//Teniendo en cuenta que hay n-1 opciones en minsculas
				//1 opcin en maysculas, y que luego habr n-1 espacios
				Utils.startHeight = (Utils.lowFont.getHeight() * (opciones.size()-1))
						+ (Utils.highFont.getHeight())
						+ ((opciones.size() - 1) * Utils.spacing);
				Utils.startHeight = (Utils.height - Utils.startHeight) / 2;
				
				g.setColor(0x00000000);
				g.fillRect(0, 0, Utils.width, Utils.height);
				
				getPantallaMemoria(g);
			break;
			case Utils.ayuda://Ayuda
				Utils.cargada=Utils.ayuda;
				Utils.linea=0;
				removeCommand(salirCommand);
				addCommand(volverCommand);
				addCommand(selectCommand);
				
	//			cargamos el fondo de pantalla de la ayuda
				Utils.cargarImagen(Utils.imAyuda);
				sprite.setImage(Utils.imagen, Utils.anchoIm, Utils.altoIm);
				sprite.setFrameSequence(Utils.getFrames(Utils.imAyuda));
				
				//vaciamos el vector opciones
				opciones.removeAllElements();
				//Aadimos las opciones disponibles a la lista.
				for(int i=0;i<Utils.opMenuAyuda.length;i++)
					opciones.addElement(Utils.opMenuAyuda[i]);
				//espacio entre las opciones del men principal
				Utils.spacing = Utils.highFont.getHeight() / 2;
				
				//Calcula la altura a la que se muestra la primera de las
				//opciones del men
				//Teniendo en cuenta que hay n-1 opciones en minsculas
				//1 opcin en maysculas, y que luego habr n-1 espacios
				Utils.startHeight = (Utils.lowFont.getHeight() * (opciones.size()-1))
						+ (Utils.highFont.getHeight())
						+ ((opciones.size() - 1) * Utils.spacing);
				Utils.startHeight = (Utils.height - Utils.startHeight) / 2;
				
				g.setColor(0x00000000);
				g.fillRect(0, 0, Utils.width, Utils.height);
				
				getPantallaAyuda(g);
			break;
			case Utils.acerca://Acerca de...
				Utils.cargada=Utils.acerca;
				Utils.linea=0;
				removeCommand(selectCommand);
				removeCommand(salirCommand);
				addCommand(volverCommand);
				
//				cargamos el fondo de pantalla del men principal
				Utils.cargarImagen(Utils.imAcerca);
				sprite.setImage(Utils.imagen, Utils.anchoIm, Utils.altoIm);
				sprite.setFrameSequence(Utils.getFrames(Utils.imAcerca));
				
				//Espacio entre cada una de las lneas de la ayuda.
				Utils.spacing=Utils.lowFont.getHeight();
				
//				Calcula la altura y anchura a la que empieza el acerca de...
				if(Utils.height<=sprite.getHeight())
					Utils.startHeight =0;
				else
					Utils.startHeight = (Utils.height / 2) - (sprite.getHeight() / 2);
				
				if(Utils.width<=sprite.getWidth())
					Utils.startWidth=Utils.lowFont.getSize() ;
				else
					Utils.startWidth=  (Utils.width / 2) - (sprite.getWidth() / 2) + Utils.lowFont.getSize() ;
				
				//inicializamos el valor de mensaje, y palabraMensaje
				Utils.mensaje.delete(0,Utils.mensaje.length());
				Utils.palabrasMensaje.removeAllElements();
				
				Utils.mensaje.append(Utils.conteAcerca);
				//Hayamos cada una de las palabras del mensaje
				StringBuffer aux2=new StringBuffer();
				for(int i=0;i<Utils.mensaje.length();i++){
					char temp=Utils.mensaje.charAt(i);
					if(temp!=' ')
						aux2.append(temp);
					else{
						Utils.palabrasMensaje.addElement(aux2.toString());
						aux2.delete(0,aux2.length());
					}
					if(i+1==Utils.mensaje.length()){
						Utils.palabrasMensaje.addElement(aux2.toString());
						aux2.delete(0,aux2.length());
					}
				}
				
				g.setColor(0x00000000);
				g.fillRect(0, 0, Utils.width, Utils.height);
				getPantallaAcerca(g);
			break;
			case Utils.opcion://opciones
				Utils.cargada=Utils.opcion;
				Utils.linea=0;
				menuOpIdx=0;
				removeCommand(salirCommand);
				addCommand(acceptCommand);
				addCommand(selectCommand);
				
//				cargamos el fondo de pantalla del men principal
				Utils.cargarImagen(Utils.imOpciones);
				sprite.setImage(Utils.imagen, Utils.anchoIm, Utils.altoIm);
				sprite.setFrameSequence(Utils.getFrames(Utils.imOpciones));
				
				menuOpIdx=0;
				//vaciamos el vector opciones
				opciones.removeAllElements();
				//establecemos las opciones
				opciones.addElement(Utils.tiposMenuTxt+ ": " + midlet.getTipoMenu());
				//espacio entre las opciones
				Utils.spacing = Utils.highFont.getHeight() / 2;
				
				//Calcula la altura a la que se muestra la primera de las
				//opciones
				//Teniendo en cuenta que hay n-1 opciones en minsculas
				//1 opcin en maysculas, y que luego habr n-1 espacios
				Utils.startHeight = (Utils.lowFont.getHeight() * (opciones.size()-1))
						+ (Utils.highFont.getHeight())
						+ ((opciones.size() - 1) * Utils.spacing);
				Utils.startHeight = (Utils.height - Utils.startHeight) / 2;
				Utils.startWidth=  (Utils.width / 2) - (sprite.getWidth() / 2) + Utils.highFont.getSize() ;
				
				g.setColor(0x00000000);
				g.fillRect(0, 0, Utils.width, Utils.height);
				
				getPantallaOpciones(g);
			break;
			default://En caso de que estemos en alguna de las opciones de la ayuda
//				para las pantallas de ayuda, en todas se hace lo mismo
//				aunque sea otro tipo de ayuda, lo que se consigue 
				//haciendo esto es que piense que cualquier tipo ya est cargado
				Utils.cargada=pantalla;
				Utils.linea=0;
				removeCommand(selectCommand);
				removeCommand(salirCommand);
				addCommand(volverCommand);
				
				//Espacio entre cada una de las lneas de la ayuda.
				Utils.spacing=Utils.lowFont.getHeight();
				
//				Calcula la altura y anchura a la que empieza la ayuda.
				if(Utils.height<=sprite.getHeight())
					Utils.startHeight =0;
				else
					Utils.startHeight = (Utils.height / 2) - (sprite.getHeight() / 2);
				
				if(Utils.width<=sprite.getWidth())
					Utils.startWidth=Utils.lowFont.getSize() ;
				else
					Utils.startWidth=  (Utils.width / 2) - (sprite.getWidth() / 2) + Utils.lowFont.getSize() ;
				
				//inicializamos el valor de mensaje, y palabraMensaje
				Utils.mensaje.delete(0,Utils.mensaje.length());
				Utils.palabrasMensaje.removeAllElements();
				
				if(pantalla==Utils.ayudaTematica)
					Utils.mensaje.append(Utils.txtSubAyuda[0]);
				else if(pantalla==Utils.ayudaTeclas)
						Utils.mensaje.append(Utils.txtSubAyuda[1]);
				else if(pantalla==Utils.ayudaVideo)
						Utils.mensaje.append(Utils.txtSubAyuda[2]);
				else if(pantalla==Utils.ayudaInventario)
						Utils.mensaje.append(Utils.txtSubAyuda[3]);
				else if(pantalla==Utils.ayudaMapa)
						Utils.mensaje.append(Utils.txtSubAyuda[4]);
				else if(pantalla==Utils.ayudaConversacion)
						Utils.mensaje.append(Utils.txtSubAyuda[5]);
				//Hayamos cada una de las palabras del mensaje
				StringBuffer palabras=new StringBuffer();
				for(int i=0;i<Utils.mensaje.length();i++){
					char temp=Utils.mensaje.charAt(i);
					if(temp!=' ')
						palabras.append(temp);
					else{
						Utils.palabrasMensaje.addElement(palabras.toString());
						palabras.delete(0,palabras.length());
					}
					if(i+1==Utils.mensaje.length()){
						Utils.palabrasMensaje.addElement(palabras.toString());
						palabras.delete(0,palabras.length());
					}
				}
				
				g.setColor(0x00000000);
				g.fillRect(0, 0, Utils.width, Utils.height);
				getPantallaSubAyuda(g);
			break;
		}
	}

	/**
	 * Mtodo llamado por el display cuando pone en pantalla
	 * este Canvas
	 */
	protected void paint(Graphics g) {
		g.setColor(0x00000000);
		g.fillRect(0, 0, getWidth(), getHeight());
		switch (Utils.parteMenu) {
			case Utils.menuPrin://Men principal
				if(Utils.cargada!=Utils.menuPrin && midlet.tipoMenu==1){
					cargar(g,Utils.menuPrin);
				}
				else
					getMenuPrincipal(g);
			break;
			case Utils.memoria://Memoria:
					if(Utils.cargada!=Utils.memoria)
						cargar(g,Utils.memoria);
					else
						getPantallaMemoria(g);
			break;
			case Utils.ayuda://Ayuda
				if(Utils.cargada!=Utils.ayuda)
					cargar(g,Utils.ayuda);
				else
					getPantallaAyuda(g);
			break;
			case Utils.acerca://Acerca de...
				if(Utils.cargada!=Utils.acerca)
					cargar(g,Utils.acerca);
				else
					getPantallaAcerca(g);
			break;
			case Utils.opcion://opciones
				if(Utils.cargada!=Utils.opcion)
					cargar(g,Utils.opcion);
				else
					getPantallaOpciones(g);
			break;
			default://En caso de que estemos en alguna de las opciones de la ayuda
				if(Utils.cargada!=Utils.parteMenu)
					cargar(g,Utils.parteMenu);
				else
					getPantallaSubAyuda(g);
			break;
		
		}
		repaint();
	}
    /**
	 * Captura la pulsacin de teclas en el men
	 */
	protected void keyPressed(int code) {
		switch (Utils.parteMenu) {
			case Utils.menuPrin:
				if (getGameAction(code) == Canvas.UP && Utils.menuPrinIdx - 1 >= 0)
					Utils.menuPrinIdx--;
				else if (getGameAction(code) == Canvas.DOWN
						&& Utils.menuPrinIdx + 1 < opciones.size()) {
						Utils.menuPrinIdx++;
				}else if(getGameAction(code) == Canvas.FIRE) {
					if(!Utils.jugando)
						Utils.menuPrinIdx++;
					switch(Utils.menuPrinIdx){
						case 0://Seguir Jugando
							midlet.seguirJugando();
						break;
						case 1://Nueva Partida
							midlet.IniciarPartida();
						break;
						case 2://Memoria
							Utils.parteMenu=Utils.memoria;
							break;
						case 3://Opciones
							Utils.parteMenu=Utils.opcion;
							break;
						case 4://Ayuda
							Utils.parteMenu=Utils.ayuda;
						break;
						case 5://Acerca de...
							Utils.parteMenu=Utils.acerca;
						break;
					}
					if(!Utils.jugando)
						Utils.menuPrinIdx--;
				}
			break;
			case Utils.memoria:
				if (getGameAction(code) == Canvas.UP && menuMemIdx - 1 >= 0) 
					menuMemIdx--;
				else if (getGameAction(code) == Canvas.DOWN
						&& menuMemIdx + 1 < opciones.size()) {
					menuMemIdx++;
				}else if(getGameAction(code) == Canvas.FIRE) {
					if(!Utils.jugando)
						menuMemIdx++;
					switch(menuMemIdx){
						case 0://Guardar Partida
							if(midlet.puedeGuardar()){
								Utils.guardandoPartida=true;
								midlet.seguirJugando();
							}
							else
								midlet.mostrarAlerta("Mientras en la partida ests en un video, " +
										"en una conversacin, o se este mostrando un mensaje, no se podr guardar " +
										"la partida",AlertType.INFO);
						break;
						case 1://Cargar Partida
							if(midlet.hayGuardada()){
								Utils.cargandoPartida=true;
								midlet.IniciarPartida();
							}
							else
								midlet.mostrarAlerta("No hay ninguna partida guardada, la cual se pueda cargar.",AlertType.INFO);
						break;
					}
					if(!Utils.jugando)
						menuMemIdx--;
				}
			break;
			case Utils.ayuda:
				if (getGameAction(code) == Canvas.UP && Utils.menuAyudaIdx - 1 >= 0) {
					Utils.menuAyudaIdx--;
					} else if (getGameAction(code) == Canvas.DOWN
						&& Utils.menuAyudaIdx + 1 < opciones.size()) {
						Utils.menuAyudaIdx++;
				}else if(getGameAction(code) == Canvas.FIRE) {
					switch(Utils.menuAyudaIdx){
						case 0://Tematica del juego
							Utils.parteMenu=Utils.ayudaTematica;
						break;
						case 1://Teclas generales
							Utils.parteMenu=Utils.ayudaTeclas;
						break;
						case 2://En un video
							Utils.parteMenu=Utils.ayudaVideo;
						break;
						case 3://En el inventario
							Utils.parteMenu=Utils.ayudaInventario;
						break;
						case 4://En el mapa
							Utils.parteMenu=Utils.ayudaMapa;
						break;
						case 5://En una conversacion
							Utils.parteMenu=Utils.ayudaConversacion;
						break;
					}
				}
			break;
			case Utils.acerca:
				if (getGameAction(code) == Canvas.UP && Utils.linea>0) 
					Utils.linea--;
				else if (getGameAction(code) == Canvas.DOWN&&Utils.numLineasMensaje-Utils.linea>Utils.numLineas)
					Utils.linea++;
	
				break;
			case Utils.opcion://opciones
				if (getGameAction(code) == Canvas.UP && menuOpIdx - 1 >= 0)
					menuOpIdx--;
				else if (getGameAction(code) == Canvas.DOWN
					&& menuOpIdx + 1 < opciones.size()) {
					menuOpIdx++;
				}else if(getGameAction(code) == Canvas.FIRE
						|| getGameAction(code) == Canvas.RIGHT
						|| getGameAction(code) == Canvas.LEFT) {
					switch(menuOpIdx){
						case 0://Tipo Menu
							switch(menuOpIdx){
								case 0://Tipo Menu
									if(midlet.tipoMenu==0)
										midlet.tipoMenu=1;
									else
										midlet.tipoMenu=0;
									//Actualizamos las opciones a mostrar
									opciones.removeElementAt(0);
									opciones.addElement(Utils.tiposMenuTxt + ": " + midlet.getTipoMenu());
								break;
							}
					    break;
					}
	
					//repaint();
				}
			break;
			default://En caso de que estemos en alguna de las opciones de la ayuda
				if (getGameAction(code) == Canvas.UP && Utils.linea>0) {
					Utils.linea--;
				}
				else if (getGameAction(code) == Canvas.DOWN&&Utils.numLineasMensaje-Utils.linea>Utils.numLineas) {
					Utils.linea++;
				}
			break;
		}
	}

    /**
	 * Cuando se pulsa un comando, viene a este metodo.
	*/
	public void commandAction(Command c, Displayable d) {
		switch (Utils.parteMenu) {
			case Utils.menuPrin://Men  principal
				if(c==selectCommand){
					if(!Utils.jugando)
						Utils.menuPrinIdx++;
					switch(Utils.menuPrinIdx){
						case 0://Seguir Jugando
							midlet.seguirJugando();
						break;
						case 1://Nueva Partida
							midlet.IniciarPartida();
						break;
						case 2://Memoria
							Utils.parteMenu=Utils.memoria;
							break;
						case 3://Opciones
							Utils.parteMenu=Utils.opcion;
							break;
						case 4://Ayuda
							Utils.parteMenu=Utils.ayuda;
						break;
						case 5://Acerca de...
							Utils.parteMenu=Utils.acerca;
						break;
					}
					if(!Utils.jugando)
						Utils.menuPrinIdx--;
				}
				else if(c==salirCommand){
					midlet.salir();
				}
				
			break;
			case Utils.memoria://Memoria
				if(c==selectCommand){
					if(!Utils.jugando)
						menuMemIdx++;
					switch(menuMemIdx){
						case 0://Guardar Partida
							if(midlet.puedeGuardar()){
								Utils.guardandoPartida=true;
								midlet.seguirJugando();
							}
							else
								midlet.mostrarAlerta("Mientras en la partida ests en un video, " +
										"en una conversacin, o se este mostrando un mensaje, no se podr guardar " +
										"la partida",AlertType.INFO);
						break;
						case 1://Cargar Partida
							if(midlet.hayGuardada()){
								Utils.cargandoPartida=true;
								midlet.IniciarPartida();
							}
							else
								midlet.mostrarAlerta("No hay ninguna partida guardada, la cual se pueda cargar.",AlertType.INFO);
						break;
					}
					if(!Utils.jugando)
						menuMemIdx--;
					
				} else if(c==volverCommand)
					Utils.parteMenu=Utils.menuPrin;
				break;
			case Utils.ayuda://Ayuda
				if(c==selectCommand){
					switch(Utils.menuAyudaIdx){
						case 0://Tematica del juego
							Utils.parteMenu=Utils.ayudaTematica;
						break;
						case 1://Teclas generales
							Utils.parteMenu=Utils.ayudaTeclas;
						break;
						case 2://En un video
							Utils.parteMenu=Utils.ayudaVideo;
						break;
						case 3://En el inventario
							Utils.parteMenu=Utils.ayudaInventario;
						break;
						case 4://En el mapa
							Utils.parteMenu=Utils.ayudaMapa;
						break;
						case 5://En una conversacion
							Utils.parteMenu=Utils.ayudaConversacion;
						break;
					}

				} else if(c==volverCommand){
					Utils.parteMenu=Utils.menuPrin;
					Utils.menuAyudaIdx=0;
				}
			break;
			case Utils.acerca://Acerca de
				if (c == volverCommand)
					Utils.parteMenu=Utils.menuPrin;
			break;
			case Utils.opcion://opciones
				if(c==selectCommand){
					switch(menuOpIdx){
						case 0://Tipo Menu
							if(midlet.tipoMenu==0)
								midlet.tipoMenu=1;
							else
								midlet.tipoMenu=0;
							//Actualizamos las opciones a mostrar
							opciones.removeElementAt(0);
							opciones.addElement(Utils.tiposMenuTxt + ": " + midlet.getTipoMenu());
							break;
					}
				}
				else if(c==acceptCommand){
					Utils.parteMenu=Utils.menuPrin;
					if(midlet.menuActivo==midlet.tipoMenu)
						repaint();
					else{
						midlet.setMenuRs();
						midlet.menu();
					}
				}
			break;
			default://En caso de que estemos en alguna de las opciones de la ayuda
				if (c == volverCommand)
					Utils.parteMenu=Utils.ayuda;
			break;
		}
			
		
	}
	
	/**
	 * Reajusta algunas variables como son el ancho y alto de la pantalla.
	 * Carga el numero de letras que caben en el ancho de la pantalla,
	 * y el numero de lneas que caben en el alto de la pantalla
	 *
	 */
	public void ajustarVariables(){
		setFullScreenMode(false);
		
		Utils.width=getWidth();
		Utils.height=getHeight();
		
		
//		cargamos el numero de letras que puede tener este grupo en una pantalla
		Utils.spaceMen=Utils.getTamGrupoX();
		switch (Utils.grupo){
			case 0://128x128
				if(Utils.height<Utils.getTamGrupoY())
					Utils.numLineas=Utils.height/Utils.lowFont.getHeight()-2;
				else
					Utils.numLineas=Utils.getTamGrupoY()/Utils.lowFont.getHeight()-2;
			break;
			case 1://176x200
				if(Utils.height<Utils.getTamGrupoY())
					Utils.numLineas=Utils.height/Utils.lowFont.getHeight()-1;
				else 
					Utils.numLineas=Utils.getTamGrupoY()/Utils.lowFont.getHeight()-1;
			break;
		}
		
	}

}